<script lang="ts">
  import { Badge, Button, Input, Table } from '@sveltestrap/sveltestrap';
  import type { TeamSettings } from '@models/Team';
  import { onMount } from 'svelte';
  import { Gql } from '@db';
  import { DeleteTeamMutation, TeamSettingsQuery } from '@queries/Team';
  import { keycloak } from '@stores';
  import { EventRole } from '@auth/models';
  import type { EventConfiguration } from '@models/EventConfigurations';
  import { AllEventCfgQuery } from '@models/EventConfigurations';
  import { faTrash } from '@fortawesome/free-solid-svg-icons';
  import Fa from 'svelte-fa';
  import { getNotificationsContext } from 'svelte-notifications';

  const { addNotification } = getNotificationsContext();
  let teams: TeamSettings[] = [];
  let eventConfigurations: EventConfiguration[] = [];
  $: queryRole = $keycloak?.getFirstRole([EventRole.SuperAdmin, EventRole.EventAdmin]);

  onMount(() => {
    Gql.subscribeSimple<{ scoreboard_team_settings: TeamSettings[] }>(
      `subscription ${TeamSettingsQuery()}`,
      (value) => (teams = value.scoreboard_team_settings),
      { queryRole },
    );

    Gql.subscribeSimple<{ events: EventConfiguration[] }>(
      `subscription ${AllEventCfgQuery}`,
      (value) => (eventConfigurations = value.events),
      { queryRole },
    );
  });

  async function setVisibility(team: TeamSettings) {
    const q = `mutation {
      update_scoreboard_team_settings_by_pk(
        pk_columns: {
          event_id: ${JSON.stringify(team.event_id)},
          team_id: ${JSON.stringify(team.team_id)}
        },
        _set: {
          visible: ${JSON.stringify(!team.visible)}
        }) {
        visible
      }
    }`;
    try {
      const response = await Gql.query<{ update_scoreboard_team_settings_by_pk: { visible: boolean } }>(q, {
        role: queryRole,
      });
      const data = response.update_scoreboard_team_settings_by_pk;
      if (!data) {
        throw new Error('Unknown Error');
      }
      console.log(team.visible, data.visible);
      team.visible = data.visible;
      addNotification({
        text: `Team is now ${team.visible ? 'visible' : 'hidden'}`,
        position: 'bottom-right',
        type: 'success',
        removeAfter: 5000,
      });
    } catch (e) {
      addNotification({
        text: `Failed to toggle visibility ${e}`,
        position: 'bottom-right',
        type: 'error',
        removeAfter: 5000,
      });
    }
  }

  async function deleteTeam(team: TeamSettings) {
    let msg = `Delete team ${team.team?.name}${team.team?.long_name ? ` (${team.team?.long_name})` : ''}?\n\n`;
    msg += `THIS WILL REMOVE:\n`;
    msg += `- ALL Scoring check configuration and results for this team\n`;
    msg += `- Team Settings\n`;
    msg += `- Team Variables\n`;
    msg += `- CTF Submissions\n`;
    msg += `- Event Registration\n`;
    msg += `- Team Membership\n`;
    msg += `- Bonus Points\n`;
    if (!window.confirm(msg)) return;
    try {
      await Gql.query(DeleteTeamMutation, { queryRole, variables: { team_id: team.team_id } });
      addNotification({
        text: `Successfully deleted team`,
        position: 'bottom-right',
        type: 'success',
        removeAfter: 5000,
      });
    } catch (e) {
      console.error(e);
      addNotification({
        text: 'Failed to delete team',
        position: 'bottom-right',
        type: 'error',
        removeAfter: 5000,
      });
    }
  }

  // todo set team visibility
  // todo add teams to team_settings table to active in an event
</script>

<h2>Team Administration</h2>

{#each eventConfigurations as event}
  <div class="my-3">
    <!--    <Badge color="success" class="clickable">Add Teams</Badge>-->
    <span class="ms-2 fs-4 text-white">{event.name}</span>
  </div>
  {#if teams.filter((t) => t.event_id === event.id).length > 0}
    <Table>
      <thead>
        <tr>
          <th />
          <th>Visible</th>
          <th>Name</th>
          <th>Long Name</th>
          <th>ID</th>
        </tr>
      </thead>
      <tbody>
        {#each teams as team}
          {#if team.event_id === event.id}
            <tr>
              <td>
                <Button on:click={() => deleteTeam(team)} color="danger"><Fa icon={faTrash} /></Button>
              </td>
              <td>
                <Input
                  class="clickable"
                  type="switch"
                  bind:checked={team.visible}
                  on:input={() => {
                    setVisibility(team);
                  }}
                />
              </td>
              <td>{team.team?.name}</td>
              <td>{team.team?.long_name || ''}</td>
              <td>{team.team?.id}</td>
            </tr>
          {/if}
        {/each}
      </tbody>
    </Table>
  {/if}
  <hr />
{/each}
